#ifndef _ZC_CALLBACK_H_
#define _ZC_CALLBACK_H_

#include <cstdlib>
#include <cstring>

// ... Yeah.

class Callback
{
public:
    typedef void (*funcType0)();
    typedef void (*funcType1)(void*);
    typedef void (*funcType2)(void*, void*);
    typedef void (*funcType3)(void*, void*, void*);
    
    Callback();
    Callback(funcType0 f); // implicit
    Callback(void* f, void* a0);
    Callback(void* f, void* a0, void* a1);
    Callback(void* f, void* a0, void* a1, void* a2);
    ~Callback();
    
    void operator()();
    void clear();
    Callback& operator=(const Callback& other);
    Callback& operator=(const funcType0 newFunc);
    inline operator bool()
    {
        return func;
    }
    
private:
    void* func;
    int numArgs;
    void* args[3];
    bool rvalue;
};

inline Callback makeCallback(Callback::funcType0 f)
{
    return Callback(f);
}

template<typename F, typename A0>
Callback makeCallback(F f, A0 a0)
{
    char* args=static_cast<char*>(malloc(sizeof(A0)));
    memcpy(args, &a0, sizeof(A0));
    return Callback(reinterpret_cast<void*>(f), args);
}

template<typename F, typename A0, typename A1>
Callback makeCallback(F f, A0 a0, A1 a1)
{
    char* args=static_cast<char*>(malloc(sizeof(A0)+sizeof(A1)));
    memcpy(args, &a0, sizeof(A0));
    memcpy(args+sizeof(A0), &a1, sizeof(A1));
    return Callback(reinterpret_cast<void*>(f), args, args+sizeof(A0));
}

template<typename F, typename A0, typename A1, typename A2>
Callback makeCallback(F f, A0 a0, A1 a1, A2 a2)
{
    char* args=static_cast<char*>(malloc(sizeof(A0)+sizeof(A1)+sizeof(A2)));
    memcpy(args, &a0, sizeof(A0));
    memcpy(args+sizeof(A0), &a1, sizeof(A1));
    memcpy(args+sizeof(A0)+sizeof(A1), &a2, sizeof(A2));
    return Callback(reinterpret_cast<void*>(f), args, args+sizeof(A0), args+sizeof(A0)+sizeof(A1));
}

#endif
